package org.jeecg.modules.ctop.controller;

import cn.com.ctop.bytedance.mapper.MaterialReportMapper;
import cn.com.ctop.common.module.entity.UserAllocation;
import cn.com.ctop.common.module.mapper.UserAllocationMapper;
import cn.com.ctop.common.module.service.IUserAllocationService;
import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.StringUtils;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.ctop.entity.Project;
import org.jeecg.modules.ctop.service.IProjectService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 用户分配
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2019-08-08
 */
@Slf4j
@Api(tags = "用户分配")
@RestController
@RequestMapping("/ctop/userAllocation")
public class UserAllocationController {
    @Autowired
    private IUserAllocationService userAllocationService;
    @Autowired
    private UserAllocationMapper userAllocationMapper;
    @Autowired
    private IProjectService projectService;
    @Autowired
    private MaterialReportMapper materialReportMapper;


    @GetMapping(value = "/getAccountList")
    public Result<List<UserAllocation>> getAccountList(String userId, Long projectId) {
        Result<List<UserAllocation>> result = new Result<>();
        try {

            QueryWrapper<UserAllocation> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("user_id", userId);
            queryWrapper.eq("project_id", projectId);
            Project project = projectService.getById(projectId);
            if (!Check.isNull(project)) {
                queryWrapper.eq("media_id", project.getMediaId());
            }

            List<UserAllocation> userAllocations = userAllocationMapper.selectList(queryWrapper);
            result.setSuccess(true);
            result.setResult(userAllocations);
        } catch (Exception e) {
            result.setSuccess(false);
            result.success("查询失败");
        }

        return result;

    }


    @GetMapping(value = "/getAccountsByProjectId")
    public Result<List<UserAllocation>> getAccountsByProjectId(String userId, Long projectId) {
        Result<List<UserAllocation>> result = new Result<>();
        try {
            QueryWrapper<UserAllocation> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("project_id", projectId);
            Project project = projectService.getById(projectId);
            if (!Check.isNull(project)) {
                queryWrapper.eq("media_id", project.getMediaId());
            }

            String roleCode = materialReportMapper.getRoleCodeByUserId(userId);
            if (!"admin".equals(roleCode) && !"kuaishouOperationManager".equals(roleCode)) {
                queryWrapper.eq("user_id", userId);
            }

            List<UserAllocation> userAllocations = userAllocationMapper.selectList(queryWrapper);
            result.setSuccess(true);
            result.setResult(userAllocations);
        } catch (Exception e) {
            result.setSuccess(false);
            result.success("查询失败");
        }

        return result;

    }


    /**
     * 统计报表 查看所有账号
     *
     * @param projectId
     * @return
     */
    @GetMapping(value = "/getAccountListByProjectId")
    public Result<List<UserAllocation>> getAccountListByProjectId(Long projectId) {
        Result<List<UserAllocation>> result = new Result<>();
        try {

            QueryWrapper<UserAllocation> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("project_id", projectId);
            Project project = projectService.getById(projectId);
            if (!Check.isNull(project)) {
                queryWrapper.eq("media_id", project.getMediaId());
            }
            List<UserAllocation> userAllocations = userAllocationMapper.selectList(queryWrapper);
            result.setSuccess(true);
            result.setResult(userAllocations);
        } catch (Exception e) {
            result.setSuccess(false);
            result.success("查询失败");
        }

        return result;

    }


    /**
     * 分页列表查询
     *
     * @param userAllocation
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "用户分配-分页列表查询")
    @ApiOperation(value = "用户分配-分页列表查询", notes = "用户分配-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<UserAllocation>> queryPageList(UserAllocation userAllocation,
                                                       @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                       @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                       HttpServletRequest req) {
        Result<IPage<UserAllocation>> result = new Result<IPage<UserAllocation>>();
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        QueryWrapper<UserAllocation> queryWrapper = QueryGenerator.initQueryWrapper(userAllocation, req.getParameterMap());
        queryWrapper.eq("user_id", user.getId());
        queryWrapper.orderByDesc("id");
        Page<UserAllocation> page = new Page<UserAllocation>(pageNo, pageSize);
        IPage<UserAllocation> pageList = userAllocationService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param userAllocation
     * @return
     */
    @AutoLog(value = "用户分配-添加")
    @ApiOperation(value = "用户分配-添加", notes = "用户分配-添加")
    @PostMapping(value = "/add")
    public Result<UserAllocation> add(@RequestBody UserAllocation userAllocation) {
        Result<UserAllocation> result = new Result<UserAllocation>();
        try {
            userAllocationService.save(userAllocation);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param userAllocation
     * @return
     */
    @AutoLog(value = "用户分配-编辑")
    @ApiOperation(value = "用户分配-编辑", notes = "用户分配-编辑")
    @PutMapping(value = "/edit")
    public Result<UserAllocation> edit(@RequestBody UserAllocation userAllocation) {
        Result<UserAllocation> result = new Result<UserAllocation>();
        UserAllocation userAllocationEntity = userAllocationService.getById(userAllocation.getId());
        if (userAllocationEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = userAllocationService.updateById(userAllocation);
            if (ok) {
                result.success("修改成功!");
            }
        }
        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "用户分配-通过id删除")
    @ApiOperation(value = "用户分配-通过id删除", notes = "用户分配-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            userAllocationService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "用户分配-批量删除")
    @ApiOperation(value = "用户分配-批量删除", notes = "用户分配-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<UserAllocation> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<UserAllocation> result = new Result<UserAllocation>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.userAllocationService.removeByIds(Arrays.asList(ids.split(StringUtils.COMMA)));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "用户分配-通过id查询")
    @ApiOperation(value = "用户分配-通过id查询", notes = "用户分配-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<UserAllocation> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<UserAllocation> result = new Result<>();
        UserAllocation userAllocation = userAllocationService.getById(id);
        if (userAllocation == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(userAllocation);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<UserAllocation> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                UserAllocation userAllocation = JSON.parseObject(deString, UserAllocation.class);
                queryWrapper = QueryGenerator.initQueryWrapper(userAllocation, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<UserAllocation> pageList = userAllocationService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "用户分配列表");
        mv.addObject(NormalExcelConstants.CLASS, UserAllocation.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("用户分配列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            // 获取上传文件对象
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<UserAllocation> listUserAllocations = ExcelImportUtil.importExcel(file.getInputStream(), UserAllocation.class, params);
                userAllocationService.saveBatch(listUserAllocations);
                return Result.ok("文件导入成功！数据行数:" + listUserAllocations.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
